#include <iostream>

using namespace std;

int main()
{
    long long t;
    cin>>t;
    for(long long k=0;k<t;k++){
        long long n,m;
        cin>>n>>m;
        long long l[n][m],u[n][m];
        for(long long i=0;i<n;i++){
            for(long long j=0;j<m;j++)
                cin>>l[i][j];
        }
        for(long long i=0;i<n;i++){
            for(long long j=0;j<m;j++)
                cin>>u[i][j];
        }
        bool f=1;
        for(long long i=0;i<n-1;i++){
            for(long long j=0;j<m-1;j++){
                if(l[i][j]+l[i+1][j+1] != l[i+1][j]+l[i][j+1])
                    f=0;
            }
        }
        if(f==0)
            cout<<"NE"<<endl;
        else if(f==1){
            cout<<"DA"<<endl;
            for(long long i=0;i<n;i++){
                for(long long j=0;j<m;j++)
                    cout<<l[i][j]<<" ";
                cout<<endl;
            }
        }
    }
}